// change these as needed
phone_slot_width=79;
phone_slot_depth=11;
lip_width=8;
wall_thickness=2.5;
holder_height=80;
bottom_gap_width=50;
bottom_corner_radius=10;

// if the lip width is more than a couple of mm,
// add supports
supports = true;
supports_spacing = 7;
supports_thickness = .4;

// shortcuts for less typing as I code this
psw=phone_slot_width;
psd=phone_slot_depth;
lw=lip_width;
wt=wall_thickness;
hh=holder_height;
bgw=bottom_gap_width;
bcr=bottom_corner_radius;
ss = supports_spacing;
st = supports_thickness;

difference() {
    union() {
        difference() {
            // blank slab
            minkowski(){
                cube([psw+2*wt-2*bcr,hh-bcr,psd+2*wt-1]);
                cylinder(r=bcr, h=1);
                }
            // minus the phone slot
            translate([wt,wt,wt])
                minkowski(){
                    cube([psw-2*bcr,hh-bcr,psd-1]);
                    cylinder(r=bcr, h=1);
                }
            }
        // add the supports
        if (supports == true) {
            // first row
            translate ([-bcr*.7,-bcr+wt+2,0]) cube([(psw+2*wt)*.9,st,psd+2*wt]);
            // fill it in
            for (yinc = [-bcr+wt+7:ss:hh])
            {
                translate ([-bcr,yinc,0]) cube([psw+2*wt,st,psd+2*wt]);
            }
            // last row
            translate ([-bcr,hh-bcr-.5,0]) cube([psw+2*wt,st,psd+2*wt]);
        }
    }
    // minus the front space
    translate([wt+lw,wt,wt])
    minkowski(){
        cube([psw-2*bcr-2*lw,hh,psd+wt]);
        cylinder(r=bcr, h=1);
        }
    // minus the bottom gap
    translate([((psw+2*wt-bgw)/2)-bcr,-bcr-wt,wt])
    cube([bgw,wt+bcr+2,psd+2*wt+2]);
    
    // chop off the top
    translate([-bcr-wt-1,hh-bcr,-1]) cube([psw+2*bcr,bcr*3,psd+2*wt+2]);
}